package dedupkey

import (
	basicnode "gitlab.dms3.io/ld/go-ld-prime/node/basic"

	"gitlab.dms3.io/dms3/go-graphsync/ldutil"
)

// EncodeDedupKey returns encoded cbor data for string key
func EncodeDedupKey(key string) ([]byte, error) {
	nb := basicnode.Prototype.String.NewBuilder()
	err := nb.AssignString(key)
	if err != nil {
		return nil, err
	}
	nd := nb.Build()
	return ldutil.EncodeNode(nd)
}

// DecodeDedupKey returns a string key decoded from cbor data
func DecodeDedupKey(data []byte) (string, error) {
	nd, err := ldutil.DecodeNode(data)
	if err != nil {
		return "", err
	}
	return nd.AsString()
}
